// Assert.h

#ifndef Assert_h
#define Assert_h

#ifndef ConfigureAssertions_h
#include "ConfigureAssertions.h"
#endif
#ifndef AssertionStream_h
#include "AssertionStream.h"
#endif

#define AssertionLineNumber(line)		#line

#define AssertionMessage( file, line, condition )       					\
	                     "File "           file          					\
	                     "; line "         AssertionLineNumber(line)	\
	                     " # Assertion ("  #condition    					\
	                     ") failed."

#define Assert(condition)                                        \
  {                                                              \
   if ( useAssertions && !( condition ) )                        \
   	AssertionStream()                                          \
   		<< AssertionMessage( __FILE__, __LINE__, condition );   \
  }

#endif
