// LinkBody.h

#ifndef LinkBody_h
#define LinkBody_h

template < class Element > class LinkBody;

template <>
class LinkBody< void >
  {
	public:
		typedef LinkBody			 value_type;
		typedef const LinkBody * const_pointer;
		typedef LinkBody *       pointer;
		typedef const LinkBody&  const_reference;
		typedef LinkBody&        reference;
		
		LinkBody()													{}
		LinkBody( const_reference )							{}
		
		LinkBody& operator=( const LinkBody& )				{ return *this; }
		void swap( LinkBody& )									{}
		
		const_reference operator*() const					{ return *this; }
		const_pointer operator->() const						{ return this; }
  };

template < class Element >
class LinkBody< const Element& >
  {
	private:
		const Element *body;
	
	public:
		typedef Element			value_type;
		typedef const Element * const_pointer;
		typedef const Element * pointer;
		typedef const Element&  const_reference;
		typedef const Element&  reference;
		
		LinkBody( const_reference theTarget )				: body( &theTarget )		{}

		LinkBody& operator=( const LinkBody& s )			{ body = s.body; return *this; }
		void swap( LinkBody& s )								{ std::swap( body, s.body ); }
		
		const_reference operator*() const					{ return *body; }
		const_pointer operator->() const						{ return body; }
  };

template < class Element >
class LinkBody< Element& >
  {
	private:
		Element *body;
	
	public:
		typedef Element	value_type;
		typedef Element * const_pointer;
		typedef Element * pointer;
		typedef Element&  const_reference;
		typedef Element&  reference;
		
		LinkBody( const_reference theTarget )				: body( &theTarget )		{}

		LinkBody& operator=( const LinkBody& s )			{ body = s.body; return *this; }
		void swap( LinkBody& )									{ std::swap( body, s.body ); }
		
		const_reference operator*() const					{ return *body; }
		const_pointer operator->() const						{ return body; }
  };

template < class Element >
class LinkBody< const Element >
  {
	private:
		Element body;
	
	public:
		typedef Element			value_type;
		typedef const Element * const_pointer;
		typedef const Element * pointer;
		typedef const Element&  const_reference;
		typedef const Element&  reference;

		LinkBody()													: body()						{}
 		LinkBody( const_reference theTarget )				: body( theTarget )		{}

		LinkBody& operator=( LinkBody& s )					{ body = s.body; return *this; }
		LinkBody& operator=( const LinkBody& s )			{ body = s.body; return *this; }
		void swap( LinkBody& s )								{ std::swap( body, s.body ); }

		reference operator*()									{ return body; }
		pointer operator->()										{ return &body; }

		const_reference operator*() const					{ return body; }
		const_pointer operator->() const						{ return &body; }
  };

template < class Element >
class LinkBody
  {
	private:
		Element body;
	
	public:
		typedef Element			value_type;
		typedef const Element * const_pointer;
		typedef       Element * pointer;
		typedef const Element&  const_reference;
		typedef       Element&  reference;

		LinkBody()													: body()						{}
 		LinkBody( const_reference theTarget )				: body( theTarget )		{}
 		LinkBody( reference theTarget )						: body( theTarget )		{}

		LinkBody& operator=( LinkBody& s )					{ body = s.body; return *this; }
		LinkBody& operator=( const LinkBody& s )			{ body = s.body; return *this; }
		void swap( LinkBody& s )								{ std::swap( body, s.body ); }

		reference operator*()									{ return body; }
		pointer operator->()										{ return &body; }

		const_reference operator*() const					{ return body; }
		const_pointer operator->() const						{ return &body; }
  };

#endif
