// RingLink.cp

#ifndef RingLink_h
#include "RingLink.h"
#endif
#include <algorithm>

RingLink::RingLink()
  : next( this ),
	 previous( this )
  {
  }

RingLink::RingLink( RingLink& source )
  : next( this ),
	 previous( this )
  {
	swap( source );
  }

RingLink::RingLink( ResourceTransfer< RingLink > source )
  : next( this ),
	 previous( this )
  {
	swap( *source );
  }

void Twist( RingLink& a, RingLink& b )
  {
	std::swap( a.previous->next, b.previous->next );
	std::swap( a.previous, b.previous );
  }

void RingLink::swap( RingLink& b )
  {
	Twist( *next, *b.next );
	Twist( *this, b );
  }

RingLink& RingLink::operator=( RingLink& b )
  {
	Twist( *this, *next );
	swap( b );
	return *this;
  }
