// RingLink.h

#ifndef RingLink_h
#define RingLink_h

#ifndef ResourceTransfer_h
#include "ResourceTransfer.h"
#endif

class RingLink
  {
	private:
		RingLink *next;
		RingLink *previous;
	
	public:
		RingLink();
		RingLink( RingLink& );
		RingLink( ResourceTransfer< RingLink > );
		
		~RingLink()																{ Unlink(); }

		operator ResourceTransfer<RingLink>()							{ return *this; }
		
		RingLink& operator=( RingLink& );
		RingLink& operator=( ResourceTransfer< RingLink > s )		{ return operator=( *s ); }

		void swap( RingLink& );		
		
		RingLink *Next()														{ return next; }
		const RingLink *Next() const										{ return next; }

		RingLink *Previous()													{ return previous; }		
		const RingLink *Previous() const									{ return previous; }
		
		bool Alone() const													{ return next == previous; }
		void Unlink()															{ Twist( *this, *next ); }
		
		friend void Twist( RingLink& a, RingLink& b );
  };

namespace std
  {
	inline void swap( RingLink& a, RingLink& b )
	  {
		a.swap( b );
	  }
  }

#endif
