// Observation.h

#ifndef Observation_h
#define Observation_h

#ifndef Closure_h
#include "Closure.h"
#endif
#ifndef LinkedList_h
#include "LinkedList.h"
#endif

template < class Signature > class ObservableBase;

template < class Signature >
class Observation
  {
	friend class ObservableBase<Signature>;
	
	private:
		typedef ::Closure< Signature > Closure;
		typedef ::LinkedList< Closure > List;
		
		List::Link link;
		
		Observation( const Closure& c )
		  : link( c )
		  {}
	
	public:
		Observation()																{}
		Observation( Observation& s )											: link( s.link )  {}
		Observation( ResourceTransfer<Observation> s )					: link( s->link ) {}
		
		Observation& operator=( Observation& s )							{ link = s.link; return *this; }
		Observation& operator=( ResourceTransfer<Observation> s )	{ return operator=( *s ); }
		
		operator ResourceTransfer<Observation>()							{ return *this; }
  };

#endif
