// PropertyPtr.h

#ifndef PropertyPtr_h
#define PropertyPtr_h

#ifndef Property_h
#include "Property.h"
#endif
#ifndef ConstPropertyPtr_h
#include "ConstPropertyPtr.h"
#endif

template < class Value >
class PropertyPtr
  {
	private:
		Property<Value> ref;
		
	public:
		PropertyPtr()
		  {}
		
		explicit PropertyPtr( const Property<Value>& r )
		  : ref( r )
		  {}
		
		PropertyPtr( const PropertyPtr& p )
		  : ref( p.ref )
		  {}

		PropertyPtr& operator=( const PropertyPtr& r )
		  {
			ref.Reseat( r.ref );
			return *this;
		  }
		
		operator ConstPropertyPtr<Value>() const		{ return ConstPropertyPtr<Value>( ref ); }
		
		const Property<Value>& operator*() const		{ return ref; }
		const Property<Value> *operator->() const		{ return &ref; }
  };

#endif
