// PropertySetterPtr.h

#ifndef PropertySetterPtr_h
#define PropertySetterPtr_h

#ifndef PropertySetter_h
#include "PropertySetter.h"
#endif

template < class Value >
class PropertySetterPtr
  {
	private:
		PropertySetter<Value> ref;
		
	public:
		PropertySetterPtr()
		  {}
		
		explicit PropertySetterPtr( const PropertySetter<Value>& r )
		  : ref( r )
		  {}
		
		PropertySetterPtr( const PropertySetterPtr& p )
		  : ref( p.ref )
		  {}

		PropertySetterPtr& operator=( const PropertySetterPtr& r )
		  {
			ref.Reseat( r.ref );
			return *this;
		  }
		
		const PropertySetter<Value>& operator*() const		{ return ref; }
		const PropertySetter<Value> *operator->() const		{ return &ref; }
  };

#endif
